Allow cross target build
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 # FIXME: HOSTS is not used in this script. Use it or Remove it.
13 HOSTS="$1"
14
15 # The second parameter is a space-separated list of the architectures the
16 # compilers will generate code for. If the current machine isn't in the list, a
17 # compiler for it will get built anyway, but won't be installed.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # The nineth parameter is the version number of the submission, e.g. 1007.
46 LLVM_SUBMIT_VERSION="$9"
47
48 # The tenth parameter is the subversion number of the submission, e.g. 03.
49 LLVM_SUBMIT_SUBVERSION="${10}"
50
51 # The current working directory is where the build will happen. It may already
52 # contain a partial result of an interrupted build, in which case this script
53 # will continue where it left off.
54 DIR=`pwd`
55
56 DARWIN_VERS=`uname -r | sed 's/\..*//'`
57 echo DARWIN_VERS = $DARWIN_VERS
58
59 if [ "x$RC_ProjectName" = "xllvmCore_Embedded" ]; then
60     DT_HOME=$DEST_DIR/Developer/Platforms/iPhoneOS.platform/Developer/usr
61     DEST_ROOT="/Developer/Platforms/iPhoneOS.platform/Developer$DEST_ROOT"
62 elif [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
63     DT_HOME=$DEST_DIR/usr
64     DEST_ROOT="/Developer$DEST_ROOT"
65 else
66     DT_HOME=$DEST_DIR/Developer/usr
67     DEST_ROOT="/Developer$DEST_ROOT"
68 fi
69 if [ "x$DEVELOPER_BIN" != "x" ]; then
70     if [ "x$RC_ProjectName" = "xllvmCore_Embedded" ]; then
71         DT_HOME=$DEST_DIR/Developer/Platforms/iPhoneOS.platform/$DEVELOPER_DIR/usr
72     else
73         DT_HOME=$DEST_DIR/$DEVELOPER_DIR/usr
74     fi
75     DEST_ROOT="/$DEVELOPER_DIR$DEST_ROOT"
76 fi
77
78 ################################################################################
79 # Run the build.
80
81 # Create the source tree we'll actually use to build, deleting
82 # tcl since it doesn't actually build properly in a cross environment
83 # and we don't really need it.
84 SRC_DIR=$DIR/src
85 rm -rf $SRC_DIR || exit 1
86 mkdir $SRC_DIR || exit 1
87 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
88 # We can't use the top-level Makefile as-is.  Remove the soft link:
89 rm $SRC_DIR/Makefile || exit 1
90 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
91 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
92
93 # Build the LLVM tree universal.
94 mkdir -p $DIR/obj-llvm || exit 1
95 cd $DIR/obj-llvm || exit 1
96
97
98 if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
99   # The cross-tools' build process expects to find an existing cross toolchain
100   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
101   rm -rf $DIR/bin || exit 1
102   mkdir $DIR/bin || exit 1
103   for prog in ar nm ranlib strip lipo ld as ; do
104     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
105     T=`xcrun -sdk $SDKROOT -find ${prog}`
106     echo '#!/bin/sh' > $P || exit 1
107     echo 'exec '$T' "$@"' >> $P || exit 1
108     chmod a+x $P || exit 1
109   done
110   # Try to use the platform llvm-gcc. Fall back to gcc if it's not available.
111   for prog in gcc g++ ; do
112     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
113 # FIXME: Uncomment once llvm-gcc works for this
114 #    T=`xcrun -find llvm-${prog}`
115 #    if [ "x$T" = "x" ] ; then
116       T=`xcrun -sdk $SDKROOT -find ${prog}`
117 #    fi
118     echo '#!/bin/sh' > $P || exit 1
119     echo 'exec '$T' -arch armv6 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
120     chmod a+x $P || exit 1
121   done
122
123   PATH=$DIR/bin:$PATH
124 # otherwise, try to use llvm-gcc if it's available
125 else
126   # If the user has set CC or CXX, respect their wishes.  If not,
127   # compile with LLVM-GCC/LLVM-G++ if available; if LLVM is not
128   # available, fall back to usual GCC/G++ default.
129   savedPATH=$PATH ; PATH="$PATH:/Developer/usr/bin"
130   XTMPCC=$(which llvm-gcc)
131   if [ x$CC  = x -a x$XTMPCC != x ] ; then export CC=$XTMPCC  ; fi
132   XTMPCC=$(which llvm-g++)
133   if [ x$CXX = x -a x$XTMPCC != x ] ; then export CXX=$XTMPCC ; fi
134   PATH=$savedPATH
135   unset XTMPCC savedPATH
136 fi
137
138
139 if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
140   if [ \! -f Makefile.config ]; then
141       $SRC_DIR/configure --prefix=$DT_HOME \
142           --enable-targets=arm \
143           --host=arm-apple-darwin10 \
144           --target=arm-apple-darwin10 \
145           --build=i686-apple-darwin10 \
146           --enable-assertions=$LLVM_ASSERTIONS \
147           --enable-optimized=$LLVM_OPTIMIZED \
148           --disable-bindings \
149           || exit 1
150   fi
151 else
152   if [ \! -f Makefile.config ]; then
153       $SRC_DIR/configure --prefix=$DT_HOME/local \
154           --enable-targets=arm,x86,powerpc,cbe \
155           --enable-assertions=$LLVM_ASSERTIONS \
156           --enable-optimized=$LLVM_OPTIMIZED \
157           --disable-bindings \
158           || exit 1
159   fi
160 fi
161
162 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
163
164 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
165     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
166     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
167     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
168 fi
169
170 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
171     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
172 else
173     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
174 fi
175
176 GCC_VER=`cc --version 2>/dev/null | sed 1q`
177
178 if echo "$GCC_VER" | grep GCC > /dev/null; then
179     GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
180     MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
181     MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
182 fi
183
184 JOBS_FLAG=""
185
186 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
187 # already has parallelism and we don't want to make the builders hit swap by
188 # firing off too many gccs at the same time.
189 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
190     # Figure out how many make processes to run.
191     SYSCTL=`sysctl -n hw.activecpu`
192
193     # hw.activecpu only available in 10.2.6 and later
194     if [ -z "$SYSCTL" ]; then
195         SYSCTL=`sysctl -n hw.ncpu`
196     fi
197
198     # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
199     # Builders can default to 2, since even if they are single processor,
200     # nothing else is running on the machine.
201     if [ -z "$SYSCTL" ]; then
202         SYSCTL=2
203     fi
204
205     JOBS_FLAG="-j $SYSCTL"
206 fi
207
208 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$TARGETS" \
209     UNIVERSAL_SDK_PATH=$SDKROOT \
210     NO_RUNTIME_LIBS=1 \
211     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
212     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
213     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
214     VERBOSE=1
215
216 if [ $? != 0 ] ; then
217     echo "error: LLVM 'make' failed!"
218     exit 1
219 fi 
220
221 ################################################################################
222 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
223 # $DEST_DIR, with occasional 'lipo' commands.
224
225 cd $DEST_DIR || exit 1
226
227 # Clean out DEST_DIR in case -noclean was passed to buildit.
228 rm -rf * || exit 1
229
230 cd $DIR/obj-llvm || exit 1
231
232 # Install the tree into the destination directory.
233 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$TARGETS" \
234     NO_RUNTIME_LIBS=1 \
235     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
236     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
237     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
238
239 if ! test $? == 0 ; then
240     echo "error: LLVM 'make install' failed!"
241     exit 1
242 fi 
243
244 # Install Version.h
245 RC_ProjectSourceSubversion=`printf "%d" $LLVM_SUBMIT_SUBVERSION`
246 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
247 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
248
249 if [ "x$LLVM_DEBUG" != "x1" ]; then
250     # Strip local symbols from llvm libraries.
251     strip -S $DEST_DIR$DEST_ROOT/lib/*.[oa]
252     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
253         strip -Sx $f
254     done
255 fi
256
257 # Copy over the tblgen utility.
258 cp `find $DIR -name tblgen` $DT_HOME/local/bin
259
260 # Remove .dir files 
261 cd $DEST_DIR$DEST_ROOT
262 rm -f bin/.dir etc/llvm/.dir lib/.dir
263
264 # Remove PPC64 fat slices.
265 cd $DEST_DIR$DEST_ROOT/bin
266 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
267     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
268         -exec lipo -extract ppc -extract i386 {} -output {} \;
269 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
270     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
271         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
272 else
273     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
274         -exec lipo -extract ppc7400 -extract i386 -extract x86_64 {} -output {} \;
275 fi
276
277 cd $DEST_DIR$DEST_ROOT
278 mkdir -p $DT_HOME/lib
279 mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
280 strip -S $DT_HOME/lib/libLTO.dylib
281 rm -f lib/libLTO.a lib/libLTO.la
282
283 # The Hello dylib is an example of how to build a pass. No need to install it.
284 rm lib/libLLVMHello.dylib
285
286 # Compress manpages
287 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
288 gzip -f $MDIR/*
289
290 ################################################################################
291 # Create SYM_DIR with information required for debugging.
292
293 # Figure out how many make processes to run.
294 SYSCTL=`sysctl -n hw.activecpu`
295
296 # hw.activecpu only available in 10.2.6 and later
297 if [ -z "$SYSCTL" ]; then
298   SYSCTL=`sysctl -n hw.ncpu`
299 fi
300
301 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
302 # can default to 2, since even if they are single processor, nothing else is
303 # running on the machine.
304 if [ -z "$SYSCTL" ]; then
305   SYSCTL=2
306 fi
307
308 cd $SYM_DIR || exit 1
309
310 # Clean out SYM_DIR in case -noclean was passed to buildit.
311 rm -rf * || exit 1
312
313 # Generate .dSYM files
314 find $DEST_DIR -perm -0111 -type f \
315     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
316     -print | xargs -n 1 -P ${SYSCTL} dsymutil
317
318 # Save .dSYM files and .a archives
319 cd $DEST_DIR || exit 1
320 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
321     | cpio -pdml $SYM_DIR || exit 1
322
323 # Save source files.
324 mkdir $SYM_DIR/src || exit 1
325 cd $DIR || exit 1
326 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
327     | cpio -pdml $SYM_DIR/src || exit 1
328
329 ################################################################################
330 # Remove debugging information from DEST_DIR.
331
332 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
333 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
334 chgrp -h -R wheel $DEST_DIR
335 chgrp -R wheel $DEST_DIR
336
337 ################################################################################
338 # Remove tar ball from docs directory
339
340 find $DEST_DIR -name html.tar.gz -exec rm {} \;
341
342 ################################################################################
343 # w00t! Done!
344
345 exit 0